from enum import Enum


class ChainTypes(str, Enum):
    """Enumeration of chain types."""

    esbocs = "esbocs"
    dag_poa = "dag_poa"


class DatumTypes(str, Enum):
    """Enumeration of datum types."""

    DATUM_TX = "DATUM_TX"
    DATUM_TOKEN_DECL = "DATUM_TOKEN_DECL"
    DATUM_TOKEN = "DATUM_TOKEN" #same as decl
    DATUM_TOKEN_EMISSION = "DATUM_TOKEN_EMISSION"
    DATUM_CUSTOM = "DATUM_CUSTOM"
    DATUM_DECREE = "DATUM_DECREE"
    DATUM_ANCHOR = "DATUM_ANCHOR"


class ItemTypes(str, Enum):
    """Enumeration of item types."""

    TX_ITEM_TYPE_IN = "TX_ITEM_TYPE_IN"
    TX_ITEM_TYPE_IN_COND = "TX_ITEM_TYPE_IN_COND"
    TX_ITEM_TYPE_OUT = "TX_ITEM_TYPE_OUT"
    TX_ITEM_TYPE_OUT_COND = "TX_ITEM_TYPE_OUT_COND"
    TX_ITEM_TYPE_PKEY = "TX_ITEM_TYPE_PKEY"
    TX_ITEM_TYPE_SIG = "TX_ITEM_TYPE_SIG"
    TX_ITEM_TYPE_IN_EMS = "TX_ITEM_TYPE_IN_EMS"  # TxToken
    TX_ITEM_TYPE_RECEIPT = "TX_ITEM_TYPE_RECEIPT"
    TX_ITEM_TYPE_OUT_EXT = "TX_ITEM_TYPE_OUT_EXT"
    TX_ITEM_TYPE_TSD = "TX_ITEM_TYPE_TSD"
    TX_ITEM_TYPE_VOTING = "TX_ITEM_TYPE_VOTING"
    TX_ITEM_TYPE_VOTE = "TX_ITEM_TYPE_VOTE"
    DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_PAY = "DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_PAY"
    DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_STAKE_LOCK = "DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_STAKE_LOCK"
    DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_XCHANGE = "DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_XCHANGE"
    DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_STAKE_POS_DELEGATE = "DAP_CHAIN_TX_OUT_COND_SUBTYPE_SRV_STAKE_POS_DELEGATE"
